global count_vowels

section .note.GNU-stack

section .text

vowel_found:
    inc r12
    jmp next_char

; void count_vowels(char *str, int *result);
;                          |          |
;                          v          v
;                        %rdi       %rsi
count_vowels:
    ; back up the pointers
    push rsi
    push rdi

    ; find string length
    mov rcx, 1024
    mov  al, 0
    ; rdi is set by caller

    repne scasb

    ; not wasting time on JNE
    ; as ZF should always equal to 1

    mov rdi, rcx
    mov rcx, 1024
    sub rcx, rdi ; strlen -> rcx
    
    ; recover *str
    pop rdi

    ; loop through the letters
    xor r12, r12 ; reset counter

    loop1:
    mov  bl, [rdi+rcx-1]
    cmp bl, 0x3F
    jle next_char ; if the symbol code <= 0x3F,
                  ; it can never be a letter

    and  bl, 0x5F ; 0x5F -> 01011111
                  ;         ^ ^
                  ;         | cut off 6th bit to cast
                  ;         | all letters to uppercase
                  ;         |
                  ;         cut off any signed nonsense
    
    cmp bl, 'A'
    je vowel_found

    cmp bl, 'Y'
    jg next_char
    je vowel_found

    cmp bl, 'E'
    je vowel_found

    cmp bl, 'I'
    je vowel_found

    cmp bl, 'O'
    je vowel_found

    cmp bl, 'U'
    je vowel_found

    next_char:
    dec rcx
    jnz loop1

    pop rsi

    ; copy result to target memory location
    mov [rsi], r12d

    ret
